Compare commits

..

1 Commits

Author SHA1 Message Date
b7a86e9841 - new workflows to test and publish aur builds 2024-04-14 01:42:46 -06:00
13 changed files with 95 additions and 343 deletions

View File

@ -44,7 +44,7 @@ commands:
custom: custom:
archlinux: archlinux:
prepare: prepare:
- &archlinux-prepare - &archlinux_prepare
run: run:
name: prepare archlinux dependencies name: prepare archlinux dependencies
command: | command: |
@ -53,18 +53,18 @@ custom:
echo "ci ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers echo "ci ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers
clone-aur: clone-aur:
- &archlinux-clone-aur - &archlinux_clone_aur
archlinux-run: archlinux-run:
_name: clone aur/scwrypts _name: clone aur/scwrypts
command: git clone https://aur.archlinux.org/scwrypts.git aur command: git clone https://aur.archlinux.org/scwrypts.git aur
clone-scwrypts: clone-scwrypts:
- &archlinux-clone-scwrypts - &archlinux_clone_scwrypts
run: run:
name: clone wrynegade/scwrypts name: clone wrynegade/scwrypts
working_directory: /home/ci working_directory: /home/ci
command: | command: |
GIT_SSH_COMMAND="ssh -o StrictHostKeyChecking=no" git clone -b "$(echo $CIRCLE_BRANCH | grep . || echo $CIRCLE_TAG)" "$CIRCLE_REPOSITORY_URL" scwrypts GIT_SSH_COMMAND="ssh -o StrictHostKeyChecking=no" git clone -b "$CIRCLE_BRANCH" "$CIRCLE_REPOSITORY_URL" scwrypts
chown -R ci:ci ./scwrypts chown -R ci:ci ./scwrypts
@ -83,9 +83,9 @@ jobs:
aur-test: aur-test:
executor: archlinux executor: archlinux
steps: steps:
- *archlinux-prepare - *archlinux_prepare
- *archlinux-clone-aur - *archlinux_clone_aur
- *archlinux-clone-scwrypts - *archlinux_clone_scwrypts
- archlinux-run: - archlinux-run:
_name: test aur build on current source _name: test aur build on current source
working_directory: /home/ci/aur working_directory: /home/ci/aur
@ -102,21 +102,21 @@ jobs:
&& echo "source=(scwrypts.tar.gz)" >> PKGBUILD && echo "source=(scwrypts.tar.gz)" >> PKGBUILD
&& echo "sha256sums=(SKIP)" >> PKGBUILD && echo "sha256sums=(SKIP)" >> PKGBUILD
&& makepkg --noconfirm -si && makepkg --noconfirm -si
&& echo validating scwrypts version
&& scwrypts --version | grep "^scwrypts v$PKGVER$" && scwrypts --version | grep "^scwrypts v$PKGVER$"
; ;
aur-publish: aur-publish:
executor: archlinux executor: archlinux
steps: steps:
- *archlinux-prepare - *archlinux_prepare
- *archlinux-clone-aur - *archlinux_clone_aur
- archlinux-run: - archlinux-run:
_name: update PKGBUILD and .SRCINFO _name: update PKGBUILD and .SRCINFO
working_directory: /home/ci/aur working_directory: /home/ci/aur
command: >- command: >-
: :
&& NEW_VERSION=$(echo $CIRCLE_TAG | sed 's/^v//') && NEW_VERSION=$(echo $CIRCLE_TAG | sed 's/^v//')
&& NEW_VERSION=4.2.0
&& sed "s/pkgver=.*/pkgver=$NEW_VERSION/; s/^pkgrel=.*/pkgrel=1/; /sha256sums/d" PKGBUILD -i && sed "s/pkgver=.*/pkgver=$NEW_VERSION/; s/^pkgrel=.*/pkgrel=1/; /sha256sums/d" PKGBUILD -i
&& makepkg -g >> PKGBUILD && makepkg -g >> PKGBUILD
&& makepkg --printsrcinfo > .SRCINFO && makepkg --printsrcinfo > .SRCINFO
@ -140,7 +140,7 @@ jobs:
&& eval $(ssh-agent) && eval $(ssh-agent)
&& echo -e $SSH_KEY_PRIVATE__AUR | ssh-add - && echo -e $SSH_KEY_PRIVATE__AUR | ssh-add -
&& git remote add upstream ssh://aur@aur.archlinux.org/scwrypts.git && git remote add upstream ssh://aur@aur.archlinux.org/scwrypts.git
&& GIT_SSH_COMMAND="ssh -o StrictHostKeyChecking=no" git push upstream && echo 'DO THE GIT_SSH_COMMAND="ssh -o StrictHostKeyChecking=no" git push upstream'
; ;
nodejs-test: nodejs-test:
@ -239,19 +239,18 @@ workflows:
test: test:
jobs: jobs:
- aur-test: - aur-test:
&dev-filters &dev_filters
filters: filters:
branches: branches:
ignore: /^main$/ ignore: /^main$/
- python-test: *dev-filters - python-test: *dev_filters
- nodejs-test: *dev-filters - nodejs-test: *dev_filters
publish: publish:
jobs: jobs:
- require-full-semver: - require-full-semver:
filters: filters:
&only-run-on-full-semver-tag-filters
tags: tags:
only: /^v\d+\.\d+\.\d+.*$/ only: /^v\d+\.\d+\.\d+.*$/
branches: branches:
@ -259,18 +258,8 @@ workflows:
- aur-test: - aur-test:
&only-publish-for-full-semver &only-publish-for-full-semver
filters: *only-run-on-full-semver-tag-filters requires: [require-full-semver]
requires:
- require-full-semver
- aur-publish: - aur-publish:
#
# there's a crazy-low-chance race-condition between this job and the GH Action '../.github/workflows/automatic-release.yaml'
# - automatic-release creates the release artifact, but takes no more than 15-30 seconds (current avg:16s max:26s)
# - this publish step requires the release artifact, but waits for all language-repository publishes to complete first (a few minutes at least)
#
# if something goes wrong, this step can be safely rerun after fixing the release artifact :)
#
filters: *only-run-on-full-semver-tag-filters
context: [aur-yage] context: [aur-yage]
requires: requires:
- aur-test - aur-test
@ -279,14 +268,10 @@ workflows:
- python-test: *only-publish-for-full-semver - python-test: *only-publish-for-full-semver
- python-publish: - python-publish:
filters: *only-run-on-full-semver-tag-filters
context: [pypi-yage]
requires: requires:
- python-test - python-test
- nodejs-test: *only-publish-for-full-semver - nodejs-test: *only-publish-for-full-semver
- nodejs-publish: - nodejs-publish:
filters: *only-run-on-full-semver-tag-filters
context: [npm-wrynegade]
requires: requires:
- nodejs-test - nodejs-test

View File

@ -2,22 +2,23 @@ from types import SimpleNamespace
from pytest import fixture from pytest import fixture
from scwrypts.test import get_generator from scwrypts.test import generate
from scwrypts.test.character_set import uri from scwrypts.test.character_set import uri
generate = get_generator({ options = {
'str_length_minimum': 8, 'str_length_minimum': 8,
'str_length_maximum': 128, 'str_length_maximum': 128,
'uuid_output_type': str, 'uuid_output_type': str,
}) }
def get_request_client_sample_data(): def get_request_client_sample_data():
return { return {
'base_url' : generate(str, {'character_set': uri}), 'base_url' : generate(str, options | {'character_set': uri}),
'endpoint' : generate(str, {'character_set': uri}), 'endpoint' : generate(str, options | {'character_set': uri}),
'method' : generate(str), 'method' : generate(str, options),
'response' : generate('requests_Response', {'depth': 4}), 'response' : generate('requests_Response', options | {'depth': 4}),
'payload' : generate(dict, { 'payload' : generate(dict, {
**options,
'depth': 1, 'depth': 1,
'data_types': { str, 'uuid' }, 'data_types': { str, 'uuid' },
}), }),
@ -29,11 +30,13 @@ def fixture_sample():
**get_request_client_sample_data(), **get_request_client_sample_data(),
headers = generate(dict, { headers = generate(dict, {
**options,
'depth': 1, 'depth': 1,
'data_types': { str, 'uuid' }, 'data_types': { str, 'uuid' },
}), }),
payload_headers = generate(dict, { payload_headers = generate(dict, {
**options,
'depth': 1, 'depth': 1,
'data_types': { str, 'uuid' }, 'data_types': { str, 'uuid' },
}), }),

View File

@ -2,14 +2,15 @@ from types import SimpleNamespace
from pytest import fixture from pytest import fixture
from scwrypts.test import generate
from scwrypts.test.character_set import uri from scwrypts.test.character_set import uri
from ..conftest import generate, get_request_client_sample_data from ..conftest import options, get_request_client_sample_data
@fixture(name='sample') @fixture(name='sample')
def fixture_sample(): def fixture_sample():
return SimpleNamespace( return SimpleNamespace(
**get_request_client_sample_data(), **get_request_client_sample_data(),
api_token = generate(str, {'character_set': uri}), api_token = generate(str, options | {'character_set': uri}),
query = generate(str), query = generate(str, options),
) )

View File

@ -3,8 +3,9 @@ from types import SimpleNamespace
from pytest import fixture from pytest import fixture
from scwrypts.test import generate
from scwrypts.test.character_set import uri from scwrypts.test.character_set import uri
from ..conftest import generate, get_request_client_sample_data from ..conftest import options, get_request_client_sample_data
@fixture(name='sample') @fixture(name='sample')
def fixture_sample(): def fixture_sample():
@ -13,12 +14,12 @@ def fixture_sample():
**get_request_client_sample_data(), **get_request_client_sample_data(),
'base_url': 'https://discord.com/api', 'base_url': 'https://discord.com/api',
}, },
bot_token = generate(str, {'character_set': uri}), bot_token = generate(str, options | {'character_set': uri}),
username = generate(str, {'character_set': ascii_letters + digits}), username = generate(str, options | {'character_set': ascii_letters + digits}),
avatar_url = generate(str, {'character_set': uri}), avatar_url = generate(str, options | {'character_set': uri}),
webhook = generate(str, {'character_set': uri}), webhook = generate(str, options | {'character_set': uri}),
channel_id = generate(str, {'character_set': uri}), channel_id = generate(str, options | {'character_set': uri}),
content_header = generate(str), content_header = generate(str, options),
content_footer = generate(str), content_footer = generate(str, options),
content = generate(str), content = generate(str, options),
) )

View File

@ -3,8 +3,9 @@ from types import SimpleNamespace
from pytest import fixture from pytest import fixture
from scwrypts.test import generate
from scwrypts.test.character_set import uri from scwrypts.test.character_set import uri
from ..conftest import generate, get_request_client_sample_data from ..conftest import options, get_request_client_sample_data
@fixture(name='sample') @fixture(name='sample')
def fixture_sample(): def fixture_sample():
@ -13,6 +14,6 @@ def fixture_sample():
**get_request_client_sample_data(), **get_request_client_sample_data(),
'base_url': 'https://api.linear.app', 'base_url': 'https://api.linear.app',
}, },
api_token = generate(str, {'character_set': uri}), api_token = generate(str, options | {'character_set': uri}),
query = generate(str), query = generate(str, options),
) )

View File

@ -13,7 +13,7 @@ class MissingFlagAndEnvironmentVariableError(EnvironmentError, ArgumentError):
class MissingScwryptsExecutableError(EnvironmentError): class MissingScwryptsExecutableError(EnvironmentError):
def __init__(self): def __init__(self):
super().__init__('scwrypts must be installed and available on your PATH') super().__init__(f'scwrypts must be installed and available on your PATH')
class BadScwryptsLookupError(ValueError): class BadScwryptsLookupError(ValueError):

View File

@ -5,54 +5,44 @@ from subprocess import run
from .exceptions import MissingScwryptsExecutableError, BadScwryptsLookupError, MissingScwryptsGroupOrTypeError from .exceptions import MissingScwryptsExecutableError, BadScwryptsLookupError, MissingScwryptsGroupOrTypeError
def scwrypts(patterns=None, args=None, executable_args=None, name=None, group=None, _type=None): def scwrypts(*args, patterns=None, name=None, group=None, _type=None, log_level=None):
''' '''
top-level scwrypts invoker from python top-level scwrypts invoker from python
patterns str / list pattern-based scwrypt lookup - patterns allows for pattern-based scwrypt lookup
args str / list arguments forwarded to the invoked scwrypt - name/group/type allos for precise-match lookup
executable_args str / list arguments for the 'scwrypts' executable
(str above assumes space-delimited values)
name str exact scwrypt lookup name (requires group and _type) *args should be a list of strings and is forwarded to the
group str exact scwrypt lookup group invoked scwrypt
_type str exact scwrypt lookup type
SCWRYPTS_EXECUTABLE configuration variable which defines the full path to scwrypts executable
see 'scwrypts --help' for more information see 'scwrypts --help' for more information
''' '''
if patterns is None and name is None: executable = which('scwrypts')
raise BadScwryptsLookupError()
if name is not None and (group is None or _type is None):
raise MissingScwryptsGroupOrTypeError(group, _type)
executable = which(getenv('SCWRYPTS_EXECUTABLE', 'scwrypts'))
if executable is None: if executable is None:
raise MissingScwryptsExecutableError() raise MissingScwryptsExecutableError()
lookup = _parse(patterns) if name is None else f'--name {name} --group {group} --type {_type}' if patterns is None and name is None:
raise BadScwryptsLookupError()
pre_args = []
if name is None:
pre_args += patterns
else:
pre_args += ['--name', name, '--group', group, '--type', _type]
if group is None or _type is None:
raise MissingScwryptsGroupOrTypeError(group, _type)
if log_level is not None:
pre_args += ['--log-level', log_level]
depth = getenv('SUBSCWRYPT', '') depth = getenv('SUBSCWRYPT', '')
if depth != '': if depth != '':
depth = int(depth) + 1 depth = int(depth) + 1
return run( return run(
f'SUBSCWRYPT={depth} {executable} {_parse(executable_args)} {lookup} -- {_parse(args)}', f'SUBSCWRYPT={depth} {executable} {" ".join(pre_args)} -- {" ".join(args)}',
shell=True, shell=True,
executable='/bin/zsh', executable='/bin/zsh',
check=False, check=False,
capture_output=True,
text=True,
) )
def _parse(string_or_list_args):
if string_or_list_args is None:
return ''
if isinstance(string_or_list_args, list):
return ' '.join(string_or_list_args)
return str(string_or_list_args)

View File

@ -1,184 +0,0 @@
from random import choice
from re import search
from string import ascii_letters, digits
from types import SimpleNamespace
from unittest.mock import patch
from pytest import fixture, raises
from scwrypts.test import get_generator
from .exceptions import MissingScwryptsExecutableError, BadScwryptsLookupError, MissingScwryptsGroupOrTypeError
from .scwrypts import scwrypts
#####################################################################
def test_scwrypts(sample, _scwrypts):
assert validate_scwrypts_output(sample, _scwrypts)
def test_scwrypts_finds_system_executable(sample, _scwrypts, mock_which):
mock_which.assert_called_once_with(sample.env['SCWRYPTS_EXECUTABLE'])
def test_scwrypts_uses_configured_executable_path(_scwrypts, mock_getenv):
mock_getenv.assert_any_call('SCWRYPTS_EXECUTABLE', 'scwrypts')
def test_scwrypts_uses_correct_depth(_scwrypts, mock_getenv):
mock_getenv.assert_any_call('SUBSCWRYPT', '')
def test_scwrypts_runs_subprocess(_scwrypts, mock_run):
mock_run.assert_called_once()
##########################################
def test_scwrypts_omit_optionals(sample, _scwrypts_omit_optionals):
assert validate_scwrypts_output(sample, _scwrypts_omit_optionals)
def test_scwrypts_omit_optionals_finds_system_executable(sample, _scwrypts_omit_optionals, mock_which):
mock_which.assert_called_once_with('scwrypts')
def test_scwrypts_omit_optionals_uses_configured_executable_path(_scwrypts_omit_optionals, mock_getenv):
mock_getenv.assert_any_call('SCWRYPTS_EXECUTABLE', 'scwrypts')
def test_scwrypts_omit_optionals_uses_correct_depth(_scwrypts_omit_optionals, mock_getenv):
mock_getenv.assert_any_call('SUBSCWRYPT', '')
def test_scwrypts_omit_optionals_runs_subprocess(_scwrypts_omit_optionals, mock_run):
mock_run.assert_called_once()
##########################################
def test_invalid_lookup_missing_patterns_and_name(sample):
sample.patterns = None
sample.name = None
with raises(BadScwryptsLookupError):
scwrypts(**get_scwrypts_args(sample))
def test_invalid_name_lookup_missing_group(sample):
sample.group = None
with raises(MissingScwryptsGroupOrTypeError):
scwrypts(**get_scwrypts_args(sample))
def test_invalid_name_lookup_missing_type(sample):
sample._type = None # pylint: disable=protected-access
with raises(MissingScwryptsGroupOrTypeError):
scwrypts(**get_scwrypts_args(sample))
def test_invalid_scwrypts_installation(sample, mock_which):
mock_which.return_value = None
with raises(MissingScwryptsExecutableError):
scwrypts(**get_scwrypts_args(sample))
#####################################################################
generate = get_generator({
'str_length_minimum': 8,
'str_length_maximum': 128,
'character_set': ascii_letters + digits + '/-_'
})
def _generate_str_or_list_arg():
random_arg = generate(list, {'data_types': {str}})
return random_arg if choice([str, list]) == list else ' '.join(random_arg)
@fixture(name='sample')
def fixture_sample():
sample = SimpleNamespace(
patterns = _generate_str_or_list_arg(),
args = _generate_str_or_list_arg(),
executable_args = _generate_str_or_list_arg(),
name = generate(str),
group = generate(str),
_type = generate(str),
executable = generate(str),
env = {
'SCWRYPTS_EXECUTABLE': generate(str),
'SUBSCWRYPT': str(generate(int, {'minimum': 1, 'maximum': 99})),
},
returncode = generate(int),
stdout = generate(str),
stderr = generate(str),
)
return sample
def get_scwrypts_args(sample):
return {
key: getattr(sample, key)
for key in [
'patterns',
'args',
'executable_args',
'name',
'group',
'_type',
]
}
#####################################################################
@fixture(name='mock_which', autouse=True)
def fixture_mock_which(sample):
with patch('scwrypts.scwrypts.scwrypts.which') as mock:
mock.return_value = sample.executable
yield mock
@fixture(name='mock_getenv', autouse=True)
def fixture_mock_getenv(sample):
with patch('scwrypts.scwrypts.scwrypts.getenv') as mock:
mock.side_effect = sample.env.get
yield mock
@fixture(name='mock_run', autouse=True)
def fixture_mock_run(sample):
with patch('scwrypts.scwrypts.scwrypts.run') as mock:
mock.side_effect = lambda *args, **_kwargs: SimpleNamespace(
args = args,
returncode = sample.returncode,
stdout = sample.stdout,
stderr = sample.stderr,
)
yield mock
#####################################################################
@fixture(name='_scwrypts')
def fixture_scwrypts(sample):
return scwrypts(**get_scwrypts_args(sample))
@fixture(name='_scwrypts_omit_optionals')
def fixture_scwrypts_omit_optionals(sample):
sample.args = None
sample.executable_args = None
del sample.env['SCWRYPTS_EXECUTABLE']
del sample.env['SUBSCWRYPT']
return scwrypts(**get_scwrypts_args(sample))
def validate_scwrypts_output(sample, output):
#
# I would love to use 'assert _scwrypts == SimpleNamespace(...expected...)'
# but the output.args is difficult to recreate without copying all the
# processing logic over from the scwrypts function
#
# opting for a bit of a strange equality test here, checking the args
# as closely as possible without copying parsing logic
#
run_args_reduced_to_a_single_string = len(output.args) == 1
run_args_follow_expected_form = search(
fr'^SUBSCWRYPT=.* {sample.executable} .*-- .*$',
output.args[0],
)
return all([
run_args_reduced_to_a_single_string,
run_args_follow_expected_form,
output.returncode == sample.returncode,
output.stdout == sample.stdout,
output.stderr == sample.stderr,
])

View File

@ -5,6 +5,6 @@ __all__ = [
'generate', 'generate',
] ]
from .generate import generate, get_generator from .generate import generate
from .character_set import * from .character_set import *

View File

@ -45,21 +45,6 @@ DEFAULT_OPTIONS = {
'requests_response_status_code': status_codes.codes[200], 'requests_response_status_code': status_codes.codes[200],
} }
def get_generator(default_options=None):
if default_options is None:
default_options = {}
def generator_function(data_type=None, options_overrides=None):
if options_overrides is None:
options_overrides = {}
return generate(
data_type = data_type,
options = default_options | options_overrides,
)
return generator_function
def generate(data_type=None, options=None): def generate(data_type=None, options=None):
''' '''
generate random data with the call of a function generate random data with the call of a function

View File

@ -6,6 +6,11 @@ source "$(dirname $(readlink -f "$0"))/zsh/lib/import.driver.zsh" || exit 42
cd "$SCWRYPTS_ROOT__scwrypts" cd "$SCWRYPTS_ROOT__scwrypts"
GIT_SCWRYPTS() { git -C "$SCWRYPTS_ROOT__scwrypts" $@; } GIT_SCWRYPTS() { git -C "$SCWRYPTS_ROOT__scwrypts" $@; }
local INSTALLATION_TYPE
[ ! -d "$SCWRYPTS_ROOT__scwrypts/.git" ] && [ ! -f "$SCWRYPTS_ROOT__scwrypts/.git" ] \
&& INSTALLATION_TYPE=$(cat "$SCWRYPTS_ROOT__scwrypts/MANAGED_BY" 2>/dev/null) \
|| INSTALLATION_TYPE=manual \
;
local ERRORS=0 local ERRORS=0
local USAGE=' local USAGE='
@ -33,7 +38,6 @@ source "$(dirname $(readlink -f "$0"))/zsh/lib/import.driver.zsh" || exit 42
-h, --help display this message and exit -h, --help display this message and exit
-l, --list print out command list and exit -l, --list print out command list and exit
--list-envs print out environment list and exit --list-envs print out environment list and exit
--root print out SCWRYPTS_ROOT__scwrypts and exit
--update update scwrypts library to latest version --update update scwrypts library to latest version
--version print out scwrypts version and exit --version print out scwrypts version and exit
@ -82,20 +86,15 @@ source "$(dirname $(readlink -f "$0"))/zsh/lib/import.driver.zsh" || exit 42
;; ;;
--version ) --version )
case $SCWRYPTS_INSTALLATION_TYPE in case $INSTALLATION_TYPE in
manual ) echo "scwrypts $(GIT_SCWRYPTS describe --tags) (via GIT)" ;; manual ) echo "scwrypts $(GIT_SCWRYPTS describe --tags) (via GIT)" ;;
* ) echo "scwrypts $(cat "$SCWRYPTS_ROOT__scwrypts/VERSION")" ;; * ) echo scwrypts $(cat "$SCWRYPTS_ROOT__scwrypts/VERSION") ;;
esac esac
return 0 return 0
;; ;;
--root )
echo "$SCWRYPTS_ROOT__scwrypts"
return 0
;;
--update ) --update )
case $SCWRYPTS_INSTALLATION_TYPE in case $INSTALLATION_TYPE in
aur ) aur )
SCWRYPTS_LOG_LEVEL=3 REMINDER " SCWRYPTS_LOG_LEVEL=3 REMINDER "
This installation is built from the AUR. Update through 'makepkg' or use This installation is built from the AUR. Update through 'makepkg' or use
@ -103,10 +102,6 @@ source "$(dirname $(readlink -f "$0"))/zsh/lib/import.driver.zsh" || exit 42
" "
;; ;;
homebrew )
SCWRYPTS_LOG_LEVEL=3 REMINDER "This installation is managed by homebrew. Update me with 'brew update scwrypts'"
;;
manual ) manual )
GIT_SCWRYPTS fetch --quiet origin main GIT_SCWRYPTS fetch --quiet origin main
GIT_SCWRYPTS fetch --quiet origin main --tags GIT_SCWRYPTS fetch --quiet origin main --tags
@ -299,17 +294,9 @@ source "$(dirname $(readlink -f "$0"))/zsh/lib/import.driver.zsh" || exit 42
[[ $ENV_REQUIRED =~ true ]] && { [[ $ENV_REQUIRED =~ true ]] && {
[ ! $ENV_NAME ] && ENV_NAME=$(SCWRYPTS__SELECT_ENV) [ ! $ENV_NAME ] && ENV_NAME=$(SCWRYPTS__SELECT_ENV)
[ ! $ENV_NAME ] && ABORT
export ENV_NAME
export SCWRYPTS_ENV=$ENV_NAME
for GROUP in ${SCWRYPTS_GROUPS[@]} for GROUP in ${SCWRYPTS_GROUPS[@]}
do do
local REQUIRED_REGEX=$(eval echo '$SCWRYPTS_REQUIRED_ENVIRONMENT_REGEX__'$GROUP)
[ $REQUIRED_REGEX ] && {
[[ $ENV_NAME =~ $REQUIRED_REGEX ]] || continue
}
local ENV_FILE=$(SCWRYPTS__GET_ENV_FILE "$ENV_NAME" "$GROUP") local ENV_FILE=$(SCWRYPTS__GET_ENV_FILE "$ENV_NAME" "$GROUP")
source "$ENV_FILE" || FAIL 5 "missing or invalid environment '$GROUP/$ENV_NAME'" source "$ENV_FILE" || FAIL 5 "missing or invalid environment '$GROUP/$ENV_NAME'"
@ -318,6 +305,8 @@ source "$(dirname $(readlink -f "$0"))/zsh/lib/import.driver.zsh" || exit 42
source "$f" || FAIL 5 "invalid static config '$f'" source "$f" || FAIL 5 "invalid static config '$f'"
done done
done done
export ENV_NAME
} }
[ $REQUIRED_ENVIRONMENT_REGEX ] && { [ $REQUIRED_ENVIRONMENT_REGEX ] && {
@ -325,12 +314,11 @@ source "$(dirname $(readlink -f "$0"))/zsh/lib/import.driver.zsh" || exit 42
|| FAIL 5 "group '$SCWRYPT_GROUP' requires current environment name to match '$REQUIRED_ENVIRONMENT_REGEX' (currently $ENV_NAME)" || FAIL 5 "group '$SCWRYPT_GROUP' requires current environment name to match '$REQUIRED_ENVIRONMENT_REGEX' (currently $ENV_NAME)"
} }
########################################## ##########################################
[ ! $SUBSCWRYPT ] && export SUBSCWRYPT=0 [ ! $SUBSCWRYPT ] && export SUBSCWRYPT=0
[[ $SCWRYPTS_INSTALLATION_TYPE =~ ^manual$ ]] && { [[ $INSTALLATION_TYPE =~ ^manual$ ]] && {
[[ $SUBSCWRYPT -eq 0 ]] && [[ $ENV_NAME =~ prod ]] && [[ $SCWRYPTS_LOG_LEVEL -gt 0 ]] && { [[ $SUBSCWRYPT -eq 0 ]] && [[ $ENV_NAME =~ prod ]] && [[ $SCWRYPTS_LOG_LEVEL -gt 0 ]] && {
STATUS "on '$ENV_NAME'; checking diff against origin/main" STATUS "on '$ENV_NAME'; checking diff against origin/main"

View File

@ -1,13 +1,11 @@
##################################################################### #####################################################################
: \ command -v scwrypts &>/dev/null || {
&& command -v scwrypts &>/dev/null \ echo 'scwrypts is required in your PATH in order to use the zsh plugins; skipping' >&2
&& source "$(scwrypts --root)/zsh/lib/import.driver.zsh" \ return 0
&& unset __SCWRYPT \ }
|| {
echo 'scwrypts must be in PATH and properly configured; skipping zsh plugin setup' >&2 NO_EXPORT_CONFIG=1 source "${0:a:h}/zsh/lib/import.driver.zsh" || return 42
return 0
}
##################################################################### #####################################################################

View File

@ -1,28 +1,14 @@
[[ $__SCWRYPT -eq 1 ]] && return 0 [[ $__SCWRYPT -eq 1 ]] && return 0
##################################################################### #####################################################################
# Apparently MacOS puts ALL of the homebrew stuff inside of a top level git repository [ ! $SCWRYPTS_ROOT ] \
# with bizarre git ignores; so: && SCWRYPTS_ROOT="$(cd $(dirname "${0:a:h}"); git rev-parse --show-toplevel 2>/dev/null)"
# - USE the git root if it's a manual install...
# - UNLESS that git root is just the $(brew --prefix)
SCWRYPTS_ROOT="$(cd -- ${0:a:h}; git rev-parse --show-toplevel 2>/dev/null | grep -v "^$(brew --prefix 2>/dev/null)$")"
[ $SCWRYPTS_ROOT ] && [ -d "$SCWRYPTS_ROOT" ] \ [ ! $SCWRYPTS_ROOT ] && [ -d /usr/share/scwrypts ] \
|| SCWRYPTS_ROOT="$(echo "${0:a:h}" | sed -n 's|\(share/scwrypts\).*$|\1|p')" && SCWRYPTS_ROOT=/usr/share/scwrypts
[ $SCWRYPTS_ROOT ] && [ -d "$SCWRYPTS_ROOT" ] || {
echo "cannot determine scwrypts root path for current installation; aborting"
exit 1
}
export SCWRYPTS_ROOT__scwrypts="$SCWRYPTS_ROOT" export SCWRYPTS_ROOT__scwrypts="$SCWRYPTS_ROOT"
[ -f "$SCWRYPTS_ROOT__scwrypts/MANAGED_BY" ] \
&& export SCWRYPTS_INSTALLATION_TYPE=$(cat "$SCWRYPTS_ROOT__scwrypts/MANAGED_BY") \
|| export SCWRYPTS_INSTALLATION_TYPE=manual \
;
##################################################################### #####################################################################
DEFAULT_CONFIG="$SCWRYPTS_ROOT/zsh/lib/config.user.zsh" DEFAULT_CONFIG="$SCWRYPTS_ROOT/zsh/lib/config.user.zsh"
@ -35,13 +21,11 @@ USER_CONFIG_OVERRIDES="$SCWRYPTS_CONFIG_PATH/config.zsh"
} }
source "$USER_CONFIG_OVERRIDES" source "$USER_CONFIG_OVERRIDES"
mkdir -p \ [ ! -d $SCWRYPTS_CONFIG_PATH ] && mkdir -p $SCWRYPTS_CONFIG_PATH
"$SCWRYPTS_CONFIG_PATH" \ [ ! -d $SCWRYPTS_DATA_PATH ] && mkdir -p $SCWRYPTS_DATA_PATH
"$SCWRYPTS_DATA_PATH" \ [ ! -d $SCWRYPTS_ENV_PATH ] && mkdir -p $SCWRYPTS_ENV_PATH
"$SCWRYPTS_ENV_PATH" \ [ ! -d $SCWRYPTS_LOG_PATH ] && mkdir -p $SCWRYPTS_LOG_PATH
"$SCWRYPTS_LOG_PATH" \ [ ! -d $SCWRYPTS_OUTPUT_PATH ] && mkdir -p $SCWRYPTS_OUTPUT_PATH
"$SCWRYPTS_OUTPUT_PATH" \
;
export \ export \
SCWRYPTS_GROUPS \ SCWRYPTS_GROUPS \
@ -78,8 +62,7 @@ done
&& [ ! "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" ] \ && [ ! "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" ] \
&& [ $GITHUB_WORKSPACE ] \ && [ $GITHUB_WORKSPACE ] \
&& [ ! $SCWRYPTS_GITHUB_NO_AUTOLOAD ] \ && [ ! $SCWRYPTS_GITHUB_NO_AUTOLOAD ] \
&& SCWRYPTS_AUTODETECT_GROUP_BASEDIR="$GITHUB_WORKSPACE" \ && SCWRYPTS_AUTODETECT_GROUP_BASEDIR="$GITHUB_WORKSPACE"
;
[ "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" ] && [ -d "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" ] && { [ "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" ] && [ -d "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" ] && {
for GROUP_LOADER in $(find "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" -type f -name \*scwrypts.zsh) for GROUP_LOADER in $(find "$SCWRYPTS_AUTODETECT_GROUP_BASEDIR" -type f -name \*scwrypts.zsh)
@ -89,4 +72,5 @@ done
} }
##################################################################### #####################################################################
__SCWRYPT=1 # arbitrary; indicates currently inside a scwrypt [ $NO_EXPORT_CONFIG ] || __SCWRYPT=1 # arbitrary; indicates currently inside a scwrypt
true